//.............................................................................
//
//   Program Name: MAKEHOTS.PRG      Copyright: Ken Klein 76655,2026
//   Date Created: 11/15/91           Language: Clipper 5.0                                         
//   Time Created: 18:42:57             Author: Ken Klein                                 
//   /brief/library.src			  
//
//	  Attempts to find a unique letter (hot key) for every array element.
//		
//	  Works pretty good in my test.  I normally found 18 to 23 unique letters
//	  out of 25 to 40 element arrays.
//		
//	  I use it to add index expression charactor strings to a menu in a
//	  data driven database shell I created.
//		
//										   			Happy Coding
//															Ken
//.............................................................................

#define HOT_NUM 1
#define HOT_CHR 2

FUNCTION MakeHots(cDel,aAr)
	LOCAL aHots := {}
	LOCAL aKey := {}
	LOCAL aPos := {}
	LOCAL i := 1, cUniq := "", c, lBreak := .T., n
	LOCAL nTries := 0														 

	cDel := IF(cDel==NIL,"~",ALLTRIM(cDel))

	FOR i := 1 TO LEN(aAr)						  // build hot key arrays array
	   AADD(aHots,{1,SUBSTR(aAr[i],1,1)})
	NEXT
	i := 1
	DO WHILE lBreak == .T.
	   IF nTries++ < LEN(aAr)*3				  	  // Prevent impossible finds

		  cUniq := BuildFlist(aAr,aHots)		  // Build array of keys
		  c := aHots[i,HOT_CHR]					  // Key to work on
		  IF FT_NOOCCUR(c, cUniq) > 1			  // More than 1 occurance ?
			 n := RAT(c,cUniq)					  // try to new key for last occur
			 IF aHots[n,HOT_NUM] < LEN(aAr[n])	  // Have we tried every char
				aHots[n,HOT_NUM] := aHots[n,HOT_NUM]+1
				aHots[n,HOT_CHR] := SUBSTR(aAr[n],aHots[n,HOT_NUM],1)
			 ELSE
				aHots[n,HOT_NUM] := 0			  // no chars left to try
			 ENDIF
			 lBreak := .T.						  // loop again
		  ELSE
			 i++
			 IF i == LEN(aHots)
				lBreak := .F.					  // Done searching
			 ENDIF
		  ENDIF

	   ELSE
		  lBreak := .F.							  // force a stop
	   ENDIF
	ENDDO
	FOR i := (-1*LEN(aAr)) TO -1				  // go from last to first 
	   IF aHots[ABS(i),HOT_NUM] != 0			  // only add delimter if unique

		  NOTE the next if checks for dups in first char to present char then
		  NOTE adds delimeter if it is unique.

		  IF FT_NOOCCUR(aHots[ABS(i),HOT_CHR], SUBSTR(cUniq,1,ABS(i))) == 1
		     aAr[ABS(i)] :=SUBSTR(aAr[ABS(i)],1,aHots[ABS(i),HOT_NUM]-1)+cDel+SUBSTR(aAr[ABS(i)],aHots[ABS(i),HOT_NUM])
		  ENDIF
	   ENDIF
	NEXT
RETURN aAr

FUNCTION BuildFlist(aAr,aHots)
	LOCAL cUniq, n
	cUniq := ""
	FOR n := 1 TO LEN(aHots)
	   cUniq := cUniq + SUBSTR(aAr[n],aHots[n,HOT_NUM],1)
	NEXT
RETURN cUniq
